## sddm 0.11.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.8)

project(SDDM)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}")
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# Silence CMake 3.0 warnings
if(POLICY CMP0043)
    cmake_policy(SET CMP0043 OLD)
endif()

# Set version
set(SDDM_VERSION_MAJOR 0)
set(SDDM_VERSION_MINOR 11)
set(SDDM_VERSION_PATCH 0)
set(SDDM_VERSION_STRING "${SDDM_VERSION_MAJOR}.${SDDM_VERSION_MINOR}.${SDDM_VERSION_PATCH}")

# Options
option(BUILD_MAN_PAGES "Build man pages" OFF)
option(ENABLE_JOURNALD "Enable logging to journald" ON)

# Definitions
add_definitions(-Wall -std=c++11)

# Default build type
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

# Handle build type
if(CMAKE_BUILD_TYPE MATCHES [Dd]ebug)
    message(STATUS "Debug build")
    add_definitions(-DDEBUG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -O0")
else()
    message(STATUS "Release build")
    add_definitions(-DNDEBUG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2")
endif()

# Default absolute paths
if(NOT DEFINED CMAKE_INSTALL_SYSCONFDIR)
    set(CMAKE_INSTALL_SYSCONFDIR "/etc")
endif()
if(NOT DEFINED CMAKE_INSTALL_LOCALSTATEDIR)
    set(CMAKE_INSTALL_LOCALSTATEDIR "/var")
endif()

# Standard installation paths
include(GNUInstallDirs)

# PKG-CONFIG
find_package(PkgConfig)

# PAM
if(NOT NO_PAM)
    find_package(PAM)

    if(PAM_FOUND)
        add_definitions(-DUSE_PAM)
    endif()
endif()

# XCB
find_package(XCB REQUIRED)

# XKB
find_package(XKB REQUIRED)

# Qt 5
find_package(Qt5Core REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5LinguistTools REQUIRED)

# find qt5 imports dir
get_target_property(QMAKE_EXECUTABLE Qt5::qmake LOCATION)
exec_program(${QMAKE_EXECUTABLE} ARGS "-query QT_INSTALL_QML" RETURN_VALUE return_code OUTPUT_VARIABLE QT_IMPORTS_DIR)

# Set components version
set(COMPONENTS_VERSION 2.0)

# Uninstall target
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
               IMMEDIATE @ONLY)

add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

# systemd
if(NOT NO_SYSTEMD)
    pkg_check_modules(SYSTEMD "systemd")
endif()

if(SYSTEMD_FOUND)
    add_definitions(-DHAVE_SYSTEMD)
    set(CMAKE_AUTOMOC_MOC_OPTIONS -DHAVE_SYSTEMD)

    pkg_check_modules(JOURNALD "libsystemd-journal")

    if(ENABLE_JOURNALD)
        if(JOURNALD_FOUND)
            add_definitions(-DHAVE_JOURNALD)
            set(CMAKE_AUTOMOC_MOC_OPTIONS -DHAVE_JOURNALD)
        else()
            message(WARNING "Disable journald support for lack of libsystemd-journal")
        endif()
    endif()

    execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=systemdsystemunitdir systemd OUTPUT_VARIABLE SYSTEMD_SYSTEM_UNIT_DIR)
    string(REGEX REPLACE "[ \t\n]+" "" SYSTEMD_SYSTEM_UNIT_DIR ${SYSTEMD_SYSTEM_UNIT_DIR})
    set(MINIMUM_VT 1)
    set(HALT_COMMAND "/usr/bin/systemctl poweroff")
    set(REBOOT_COMMAND "/usr/bin/systemctl reboot")
else()
    set(SYSTEMD_FOUND 0)
    set(MINIMUM_VT 7)
    set(HALT_COMMAND "/sbin/shutdown -h -P now")
    set(REBOOT_COMMAND "/sbin/shutdown -r now")
endif()

# Set constants
set(DATA_INSTALL_DIR            "${CMAKE_INSTALL_FULL_DATADIR}/sddm"                CACHE PATH      "System application data install directory")
set(DBUS_CONFIG_DIR             "${CMAKE_INSTALL_SYSCONFDIR}/dbus-1/system.d"       CACHE PATH      "DBus config files directory")
set(STATE_DIR                   "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/sddm"      CACHE PATH      "State directory")
set(RUNTIME_DIR                 "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/run/sddm"      CACHE PATH      "Runtime data storage directory")

set(SESSION_COMMAND             "${DATA_INSTALL_DIR}/scripts/Xsession"              CACHE PATH      "Script to execute when starting the desktop session")

set(CONFIG_FILE                 "${CMAKE_INSTALL_FULL_SYSCONFDIR}/sddm.conf"        CACHE PATH      "Path of the sddm config file")
set(LOG_FILE                    "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/log/sddm.log"  CACHE PATH      "Path of the sddm log file")
set(COMPONENTS_TRANSLATION_DIR  "${DATA_INSTALL_DIR}/translations"                  CACHE PATH      "Components translations directory")

# Add subdirectories
add_subdirectory(components)
add_subdirectory(data)
add_subdirectory(services)
add_subdirectory(src)
add_subdirectory(test)

=== data/CMakeLists.txt ===
install(DIRECTORY   "faces"                             DESTINATION "${DATA_INSTALL_DIR}")
install(DIRECTORY   "flags"                             DESTINATION "${DATA_INSTALL_DIR}")

install(FILES "org.freedesktop.DisplayManager.conf"       DESTINATION "${DBUS_CONFIG_DIR}")

install(FILES "scripts/Xsession" "scripts/Xsetup" DESTINATION "${DATA_INSTALL_DIR}/scripts"
        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
        GROUP_READ GROUP_EXECUTE
        WORLD_READ WORLD_EXECUTE)

if(BUILD_MAN_PAGES)
    add_subdirectory(man)
endif()
add_subdirectory(themes)
add_subdirectory(translations)

=== data/translations/CMakeLists.txt ===
set(TRANSLATION_FILES
    cs.ts
    de.ts
    et.ts
    fi.ts
    fr.ts
    it.ts
    ja.ts
    pl.ts
    pt_BR.ts
    pt_PT.ts
    ro.ts
    ru.ts
    tr.ts
    zh_CN.ts
    lt.ts
)

qt5_add_translation(QM_FILES ${TRANSLATION_FILES})

install(FILES ${QM_FILES} DESTINATION "${COMPONENTS_TRANSLATION_DIR}")

add_custom_target(components-translation DEPENDS ${QM_FILES})

=== src/daemon/CMakeLists.txt ===
include_directories(
    "${CMAKE_SOURCE_DIR}/src/common"
    "${CMAKE_SOURCE_DIR}/src/auth"
)
include_directories("${CMAKE_BINARY_DIR}/src/common")

set(DAEMON_SOURCES
    ${CMAKE_SOURCE_DIR}/src/common/Configuration.cpp
    ${CMAKE_SOURCE_DIR}/src/common/SafeDataStream.cpp
    ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.cpp
    ${CMAKE_SOURCE_DIR}/src/common/SocketWriter.cpp
    ${CMAKE_SOURCE_DIR}/src/auth/Auth.cpp
    ${CMAKE_SOURCE_DIR}/src/auth/AuthPrompt.cpp
    ${CMAKE_SOURCE_DIR}/src/auth/AuthRequest.cpp
    DaemonApp.cpp
    Display.cpp
    DisplayManager.cpp
    DisplayServer.cpp
    XorgDisplayServer.cpp
    Greeter.cpp
    PowerManager.cpp
    Seat.cpp
    SeatManager.cpp
    SignalHandler.cpp
    SocketServer.cpp
)

qt5_add_dbus_adaptor(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.DisplayManager.xml"          "DisplayManager.h" SDDM::DisplayManager)
qt5_add_dbus_adaptor(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.DisplayManager.Seat.xml"     "DisplayManager.h" SDDM::DisplayManagerSeat)
qt5_add_dbus_adaptor(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.DisplayManager.Session.xml"  "DisplayManager.h" SDDM::DisplayManagerSession)

add_executable(sddm ${DAEMON_SOURCES})
target_link_libraries(sddm ${LIBXCB_LIBRARIES})
if(PAM_FOUND)
    target_link_libraries(sddm ${PAM_LIBRARIES})
else()
    target_link_libraries(sddm crypt)
endif()
qt5_use_modules(sddm DBus Network Qml)

if(JOURNALD_FOUND)
    target_link_libraries(sddm ${JOURNALD_LIBRARIES})
endif()

install(TARGETS sddm DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== src/greeter/CMakeLists.txt ===
include_directories("${CMAKE_SOURCE_DIR}/src/common")
include_directories("${CMAKE_BINARY_DIR}/src/common")

set(GREETER_SOURCES
    ${CMAKE_SOURCE_DIR}/src/common/Configuration.cpp
    ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.cpp
    ${CMAKE_SOURCE_DIR}/src/common/SocketWriter.cpp
    GreeterApp.cpp
    GreeterProxy.cpp
    KeyboardModel.cpp
    ScreenModel.cpp
    SessionModel.cpp
    ThemeConfig.cpp
    ThemeMetadata.cpp
    UserModel.cpp
)

add_executable(sddm-greeter ${GREETER_SOURCES})
target_link_libraries(sddm-greeter ${LIBXCB_LIBRARIES} ${LIBXKB_LIBRARIES})
qt5_use_modules(sddm-greeter Quick)

if(JOURNALD_FOUND)
    target_link_libraries(sddm-greeter ${JOURNALD_LIBRARIES})
endif()

# Translations
add_dependencies(sddm-greeter components-translation)
add_dependencies(sddm-greeter themes-translation)

install(TARGETS sddm-greeter DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== debian/changelog ===
sddm (0.11.0-0ubuntu5) vivid; urgency=medium

  * Add upstream_add-graphical.target.diff from upstream

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 18 Mar 2015 18:31:32 +0100

sddm (0.11.0-0ubuntu4) vivid; urgency=medium

  * Add kubuntu_minimum_vt.diff to set minimum vt to 7

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 11 Mar 2015 17:02:02 +0100

sddm (0.11.0-0ubuntu3) vivid; urgency=medium

  * Re-enable systemd integration and install the sddm.service again

 -- Philip Muškovac <yofel@kubuntu.org>  Sun, 14 Dec 2014 19:02:38 +0100

sddm (0.11.0-0ubuntu2) vivid; urgency=medium

  * Sync with packaging from kubuntu_unstable

 -- Rohan Garg <rohangarg@kubuntu.org>  Thu, 20 Nov 2014 17:58:48 +0100

sddm (0.11.0-0ubuntu1) vivid; urgency=medium

  * New upstream release

 -- Rohan Garg <rohangarg@kubuntu.org>  Thu, 20 Nov 2014 17:57:57 +0100

sddm (0.10.0+dfsg1-0ubuntu1) vivid; urgency=medium

  * Initial archive upload
  * Replace file data/themes/maldives/maldives.jpg and
    data/themes/maldives/background.jpg background file with a free
    image, https://github.com/sddm/sddm/issues/315

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 17 Oct 2014 15:39:42 +0200

=== debian/control ===
Source: sddm
Section: kde
Priority: optional
Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Michał Zając <quintasan@kubuntu.org>
Build-Depends: cmake (>= 2.8.8),
               debhelper (>= 9),
               dh-systemd [linux-any],
               libpam0g-dev,
               libsystemd-login-dev,
               libupower-glib-dev,
               libxcb-xkb-dev,
               libxcb1-dev,
               pkg-config,
               qtbase5-dev,
               qtdeclarative5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               systemd [linux-any]
Standards-Version: 3.9.6
Homepage: https://github.com/sddm/sddm
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-kde/kde-std/sddm.git
Vcs-Git: git://anonscm.debian.org/pkg-kde/kde-std/sddm.git

Package: sddm
Architecture: any
Depends: adduser,
         qml-module-qtquick2,
         sddm-theme-breeze | sddm-theme,
         ${misc:Depends},
         ${shlibs:Depends}
Description: modern display manager for X11
 SDDM is a modern display manager for X11 aiming to be fast, simple
 and beautiful. It uses modern technologies like QtQuick to create
 smooth, animated user interfaces.

Package: sddm-theme-maui
Architecture: all
Depends: ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Description: 'Maui' theme for SDDM X11 display manager
 Maui theme for SDDM

Package: sddm-theme-circles
Architecture: all
Depends: ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Description: 'Circles' theme for SDDM X11 display manager
 Circles theme for SDDM

Package: sddm-theme-elarun
Architecture: all
Depends: ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Description: 'Elarun' Theme for SDDM X11 display manager
 Elarun theme for SDDM

Package: sddm-theme-maldives
Architecture: all
Depends: ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Description: 'Maldives' theme for SDDM X11 display manager
 Maldives theme for SDDM

Package: sddm-dbg
Depends: sddm (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Architecture: any
Section: debug
Priority: extra
Description: modern display manager for X11 -- debugging symbols
 SDDM is a modern display manager for X11 aiming to be fast, simple
 and beautiful. It uses modern technologies like QtQuick to create
 smooth, animated user interfaces.
 .
 Debugging symbols for SDDM

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
WITH_SYSTEMD := $(shell dpkg-architecture -qDEB_HOST_ARCH -ilinux-any && echo --with systemd)

%:
	dh $@ ${WITH_SYSTEMD} --parallel

override_dh_strip:
	dh_strip --dbg-package=sddm-dbg

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_QT5=TRUE -DCMAKE_INSTALL_LIBEXECDIR=/usr/lib/${DEB_HOST_MULTIARCH}/sddm

override_dh_systemd_start:
	dh_systemd_start -psddm --no-start -r sddm.service

override_dh_installinit:
	dh_installinit --no-start

override_dh_installpam:
	dh_installpam
	dh_installpam --name=sddm-autologin
	dh_installpam --name=sddm-greeter

=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*/)?v?(\d[\d.]*)\.tar\.gz/sddm-$1.tar.gz/" \
         https://github.com/sddm/sddm/tags (?:.*/)?v?(\d[\d.]*)\.tar\.gz

## sddm 0.13.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,16 +14,27 @@
 
 # Set version
 set(SDDM_VERSION_MAJOR 0)
-set(SDDM_VERSION_MINOR 11)
+set(SDDM_VERSION_MINOR 13)
 set(SDDM_VERSION_PATCH 0)
 set(SDDM_VERSION_STRING "${SDDM_VERSION_MAJOR}.${SDDM_VERSION_MINOR}.${SDDM_VERSION_PATCH}")
+
+# Set up packaging
+set(CPACK_PACKAGE_NAME "sddm")
+set(CPACK_PACKAGE_VERSION "${SDDM_VERSION_STRING}")
+set(CPACK_GENERATOR "TGZ")
+set(CPACK_SET_DESTDIR FALSE)
+set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}")
+set(CPACK_SOURCE_IGNORE_FILES "/build/;/.git;/*.user;/.tx/;~$;${CPACK_SOURCE_IGNORE_FILES}")
+include(CPack)
+add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
 
 # Options
 option(BUILD_MAN_PAGES "Build man pages" OFF)
 option(ENABLE_JOURNALD "Enable logging to journald" ON)
+option(ENABLE_PAM "Enable PAM support" ON)
 
 # Definitions
-add_definitions(-Wall -std=c++11)
+add_definitions(-Wall -std=c++11 -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_FROM_BYTEARRAY)
 
 # Default build type
 if(NOT CMAKE_BUILD_TYPE)
@@ -52,17 +63,21 @@
 # Standard installation paths
 include(GNUInstallDirs)
 
+# Macros
+include(FeatureSummary)
+
 # PKG-CONFIG
 find_package(PkgConfig)
 
 # PAM
-if(NOT NO_PAM)
-    find_package(PAM)
+if(ENABLE_PAM)
+    find_package(PAM REQUIRED)
 
     if(PAM_FOUND)
         add_definitions(-DUSE_PAM)
     endif()
 endif()
+add_feature_info("PAM" PAM_FOUND "PAM support")
 
 # XCB
 find_package(XCB REQUIRED)
@@ -77,7 +92,9 @@
 
 # find qt5 imports dir
 get_target_property(QMAKE_EXECUTABLE Qt5::qmake LOCATION)
-exec_program(${QMAKE_EXECUTABLE} ARGS "-query QT_INSTALL_QML" RETURN_VALUE return_code OUTPUT_VARIABLE QT_IMPORTS_DIR)
+if(NOT QT_IMPORTS_DIR)
+    exec_program(${QMAKE_EXECUTABLE} ARGS "-query QT_INSTALL_QML" RETURN_VALUE return_code OUTPUT_VARIABLE QT_IMPORTS_DIR)
+endif()
 
 # Set components version
 set(COMPONENTS_VERSION 2.0)
@@ -98,7 +115,12 @@
     add_definitions(-DHAVE_SYSTEMD)
     set(CMAKE_AUTOMOC_MOC_OPTIONS -DHAVE_SYSTEMD)
 
-    pkg_check_modules(JOURNALD "libsystemd-journal")
+    # libsystemd-journal was merged into libsystemd in 209
+    if(${SYSTEMD_VERSION} VERSION_LESS 209)
+        pkg_check_modules(JOURNALD "libsystemd-journal")
+    else()
+        pkg_check_modules(JOURNALD "libsystemd")
+    endif()
 
     if(ENABLE_JOURNALD)
         if(JOURNALD_FOUND)
@@ -109,8 +131,11 @@
         endif()
     endif()
 
-    execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=systemdsystemunitdir systemd OUTPUT_VARIABLE SYSTEMD_SYSTEM_UNIT_DIR)
-    string(REGEX REPLACE "[ \t\n]+" "" SYSTEMD_SYSTEM_UNIT_DIR ${SYSTEMD_SYSTEM_UNIT_DIR})
+    if (NOT DEFINED SYSTEMD_SYSTEM_UNIT_DIR)
+        execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=systemdsystemunitdir systemd OUTPUT_VARIABLE SYSTEMD_SYSTEM_UNIT_DIR)
+        string(REGEX REPLACE "[ \t\n]+" "" SYSTEMD_SYSTEM_UNIT_DIR ${SYSTEMD_SYSTEM_UNIT_DIR})
+    endif()
+
     set(MINIMUM_VT 1)
     set(HALT_COMMAND "/usr/bin/systemctl poweroff")
     set(REBOOT_COMMAND "/usr/bin/systemctl reboot")
@@ -127,11 +152,45 @@
 set(STATE_DIR                   "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/sddm"      CACHE PATH      "State directory")
 set(RUNTIME_DIR                 "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/run/sddm"      CACHE PATH      "Runtime data storage directory")
 
-set(SESSION_COMMAND             "${DATA_INSTALL_DIR}/scripts/Xsession"              CACHE PATH      "Script to execute when starting the desktop session")
+set(SESSION_COMMAND             "${DATA_INSTALL_DIR}/scripts/Xsession"              CACHE PATH      "Script to execute when starting the X11 desktop session")
+set(WAYLAND_SESSION_COMMAND     "${DATA_INSTALL_DIR}/scripts/wayland-session"       CACHE PATH      "Script to execute when starting the Wayland desktop session")
 
 set(CONFIG_FILE                 "${CMAKE_INSTALL_FULL_SYSCONFDIR}/sddm.conf"        CACHE PATH      "Path of the sddm config file")
 set(LOG_FILE                    "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/log/sddm.log"  CACHE PATH      "Path of the sddm log file")
+set(DBUS_CONFIG_FILENAME        "org.freedesktop.DisplayManager.conf"               CACHE STRING    "Name of the sddm config file")
 set(COMPONENTS_TRANSLATION_DIR  "${DATA_INSTALL_DIR}/translations"                  CACHE PATH      "Components translations directory")
+
+
+# Autodetect UID_MIN and UID_MAX from /etc/login.defs
+if(NOT DEFINED LOGIN_DEFS_PATH)
+    set(LOGIN_DEFS_PATH "/etc/login.defs" CACHE PATH "Path to login.defs")
+endif()
+
+if(NOT EXISTS "${LOGIN_DEFS_PATH}" AND NOT DEFINED UID_MIN AND NOT DEFINED UID_MAX)
+    message(FATAL_ERROR "Could not find login.defs at ${LOGIN_DEFS_PATH}. Try -DLOGIN_DEFS_PATH.")
+endif()
+
+if(NOT DEFINED UID_MIN)
+    file(STRINGS "${LOGIN_DEFS_PATH}" UID_MIN LIMIT_COUNT 1 REGEX "^UID_MIN")
+    string(REGEX REPLACE "^UID_MIN[\t ]+([0-9]+)" "\\1" UID_MIN "${UID_MIN}")
+    if(NOT UID_MIN MATCHES "[0-9]+")
+        message(WARNING "Could not detect a valid UID_MIN (got '${UID_MIN}'). You should review your login.defs file.")
+        set(UID_MIN 1000)
+    else()
+        message(STATUS "Autodetected UID_MIN=${UID_MIN} from ${LOGIN_DEFS_PATH}")
+    endif()
+endif()
+
+if(NOT DEFINED UID_MAX)
+    file(STRINGS "${LOGIN_DEFS_PATH}" UID_MAX LIMIT_COUNT 1 REGEX "^UID_MAX")
+    string(REGEX REPLACE "^UID_MAX[\t ]+([0-9]+)" "\\1" UID_MAX "${UID_MAX}")
+    if(NOT UID_MAX MATCHES "[0-9]+")
+        message(WARNING "Could not detect a valid UID_MAX (got '${UID_MAX}'). You should review your login.defs file.")
+        set(UID_MAX 65000)
+    else()
+        message(STATUS "Autodetected UID_MAX=${UID_MAX} from ${LOGIN_DEFS_PATH}")
+    endif()
+endif()
 
 # Add subdirectories
 add_subdirectory(components)
@@ -139,3 +198,6 @@
 add_subdirectory(services)
 add_subdirectory(src)
 add_subdirectory(test)
+
+# Display feature summary
+feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== data/CMakeLists.txt ===
install(DIRECTORY "faces" DESTINATION "${DATA_INSTALL_DIR}")
install(DIRECTORY "flags" DESTINATION "${DATA_INSTALL_DIR}")

install(FILES
    "org.freedesktop.DisplayManager.conf"
    DESTINATION "${DBUS_CONFIG_DIR}"
    RENAME ${DBUS_CONFIG_FILENAME}
)

install(FILES
    "scripts/Xsession"
    "scripts/Xsetup"
    "scripts/Xstop"
    "scripts/wayland-session"
    DESTINATION "${DATA_INSTALL_DIR}/scripts"
    PERMISSIONS
        OWNER_READ OWNER_WRITE OWNER_EXECUTE
        GROUP_READ GROUP_EXECUTE
        WORLD_READ WORLD_EXECUTE
)

if(BUILD_MAN_PAGES)
    add_subdirectory(man)
endif()
add_subdirectory(themes)
add_subdirectory(translations)

=== services/CMakeLists.txt ===
if(SYSTEMD_FOUND)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/sddm.service.in" "${CMAKE_CURRENT_BINARY_DIR}/sddm.service")
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sddm.service" DESTINATION "${SYSTEMD_SYSTEM_UNIT_DIR}")
endif()

install(FILES sddm.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME sddm)
install(FILES sddm-autologin.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME sddm-autologin)
install(FILES sddm-greeter.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME sddm-greeter)

=== src/CMakeLists.txt ===
configure_file("common/Constants.h.in" "common/Constants.h" IMMEDIATE @ONLY)

add_subdirectory(daemon)
add_subdirectory(greeter)
add_subdirectory(helper)

=== data/themes/CMakeLists.txt ===
set(THEMES circles elarun maldives maui)

foreach(THEME ${THEMES})
    # We assume that theme-specific translations are stored
    # in ${THEME}/translations directory
    set(TRANSLATIONS_DIR "${THEME}/translations")
    file(GLOB TRANSLATION_SOURCES "${TRANSLATIONS_DIR}/*.ts")

    configure_file("${THEME}/Main.qml"                  "${THEME}/Main.qml")
    configure_file("${THEME}/metadata.desktop"          "${THEME}/metadata.desktop")

    set_source_files_properties(${TRANSLATION_SOURCES} PROPERTIES OUTPUT_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/${TRANSLATIONS_DIR}")

    qt5_add_translation(QM_FILES "${TRANSLATION_SOURCES}")

    install(DIRECTORY "${THEME}" DESTINATION "${DATA_INSTALL_DIR}/themes" PATTERN "*.ts" EXCLUDE)
    install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${THEME}" DESTINATION "${DATA_INSTALL_DIR}/themes")

    list(APPEND THEMES_QM_FILES ${QM_FILES})
endforeach(THEME)

add_custom_target(themes-translation DEPENDS ${THEMES_QM_FILES})

=== data/translations/CMakeLists.txt ===
--- 
+++ 
@@ -1,19 +1,29 @@
 set(TRANSLATION_FILES
+    ar.ts
     cs.ts
     de.ts
+    es.ts
     et.ts
     fi.ts
     fr.ts
+    hu.ts
     it.ts
     ja.ts
+    ko.ts
+    lt.ts
+    lv.ts
     pl.ts
     pt_BR.ts
     pt_PT.ts
     ro.ts
+    sr.ts
+    sr@ijekavian.ts
+    sr@ijekavianlatin.ts
+    sr@latin.ts
     ru.ts
     tr.ts
     zh_CN.ts
-    lt.ts
+    zh_TW.ts
 )
 
 qt5_add_translation(QM_FILES ${TRANSLATION_FILES})

=== src/daemon/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,7 @@
     ${CMAKE_SOURCE_DIR}/src/common/Configuration.cpp
     ${CMAKE_SOURCE_DIR}/src/common/SafeDataStream.cpp
     ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.cpp
+    ${CMAKE_SOURCE_DIR}/src/common/Session.cpp
     ${CMAKE_SOURCE_DIR}/src/common/SocketWriter.cpp
     ${CMAKE_SOURCE_DIR}/src/auth/Auth.cpp
     ${CMAKE_SOURCE_DIR}/src/auth/AuthPrompt.cpp
@@ -23,6 +24,7 @@
     SeatManager.cpp
     SignalHandler.cpp
     SocketServer.cpp
+    VirtualTerminal.cpp
 )
 
 qt5_add_dbus_adaptor(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.DisplayManager.xml"          "DisplayManager.h" SDDM::DisplayManager)

=== src/greeter/CMakeLists.txt ===
--- 
+++ 
@@ -4,15 +4,18 @@
 set(GREETER_SOURCES
     ${CMAKE_SOURCE_DIR}/src/common/Configuration.cpp
     ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.cpp
+    ${CMAKE_SOURCE_DIR}/src/common/Session.cpp
     ${CMAKE_SOURCE_DIR}/src/common/SocketWriter.cpp
     GreeterApp.cpp
     GreeterProxy.cpp
+    KeyboardLayout.cpp
     KeyboardModel.cpp
     ScreenModel.cpp
     SessionModel.cpp
     ThemeConfig.cpp
     ThemeMetadata.cpp
     UserModel.cpp
+    XcbKeyboardBackend.cpp
 )
 
 add_executable(sddm-greeter ${GREETER_SOURCES})

=== src/helper/CMakeLists.txt ===
include_directories(
    "${CMAKE_SOURCE_DIR}/src/common"
    "${CMAKE_SOURCE_DIR}/src/auth"
)
include_directories("${CMAKE_BINARY_DIR}/src/common")

set(HELPER_SOURCES
    ${CMAKE_SOURCE_DIR}/src/common/Configuration.cpp
    ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.cpp
    ${CMAKE_SOURCE_DIR}/src/common/SafeDataStream.cpp
    Backend.cpp
    HelperApp.cpp
    UserSession.cpp
)

if(PAM_FOUND)
    set(HELPER_SOURCES
        ${HELPER_SOURCES}
        backend/PamHandle.cpp
        backend/PamBackend.cpp
    )
else()
    set(HELPER_SOURCES
        ${HELPER_SOURCES}
        backend/PasswdBackend.cpp
    )
endif()

add_executable(sddm-helper ${HELPER_SOURCES})
qt5_use_modules(sddm-helper Network)
if(PAM_FOUND)
    target_link_libraries(sddm-helper ${PAM_LIBRARIES})
else()
    target_link_libraries(sddm-helper crypt)
endif()

if(JOURNALD_FOUND)
    target_link_libraries(sddm-helper ${JOURNALD_LIBRARIES})
endif()

install(TARGETS sddm-helper RUNTIME DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}")

=== debian/changelog ===
sddm (0.13.0-1ubuntu5) xenial; urgency=medium

  * Cherry-pick cb768895c8e0d21c689d63f69d7ac668fe4e8fa6 so there is a working
    way to login if autologin fails on an invalid session config

 -- Philip Muškovac <yofel@kubuntu.org>  Fri, 15 Jan 2016 01:25:13 +0100

sddm (0.13.0-1ubuntu4) xenial; urgency=medium

  * Switch the watch file back to gz as xz lookup on GitHub isn't really
    possible 
  * Restore kwallet4 auto-start that was dropped in the debian merge

 -- Philip Muškovac <yofel@kubuntu.org>  Sun, 10 Jan 2016 15:40:55 +0100

sddm (0.13.0-1ubuntu3) xenial; urgency=medium

  * Mark wayland-session as a conffile as well
  * Switch the watch file from gz to xz

 -- Philip Muškovac <yofel@kubuntu.org>  Fri, 08 Jan 2016 11:15:01 +0100

sddm (0.13.0-1ubuntu2) xenial; urgency=medium

  * Mark Xstart, Xsession and Xstop as conffiles as they are supposed to be
    editable by users (LP: #1531465)

 -- Philip Muškovac <yofel@kubuntu.org>  Fri, 08 Jan 2016 10:44:21 +0100

sddm (0.13.0-1ubuntu1) xenial; urgency=medium

  * Merge with debian unstable (LP: #1519564, #1516837, #1511286)
    remaining changes: 
    - keep the default-display-manager file logic in sddm.postinst
    - keep kubuntu specific patches:
      + kubuntu_nvidia-prime.diff
      + kubuntu_minimum_vt.diff instead of 03_vt7-minimum-vt.diff

 -- Philip Muškovac <yofel@kubuntu.org>  Tue, 05 Jan 2016 16:15:05 +0100

sddm (0.13.0-1) unstable; urgency=medium

  * Team Upload
  [ Diane Trout ]
  * New upstream release.
  * Remove CVE-2015-0856.patch applied upstream.
  * Refresh patches.
  * Build man pages
    - Add python-docutils to Build-Depends
    - Add built man pages to sddm.install

  [ Scott Kitterman ]
  * Add missing debian/changelog entry from previous revision
  * Apply sddm.pam.diff (provided by Alf Gaida - Thanks!) and add
    libpam-systemd to sddm Recommends to fix session problems while using
    systemd while still allowing non-systemd installations (Closes: #799837,
    #806758)

 -- Diane Trout <diane@ghic.org>  Mon, 04 Jan 2016 22:23:34 -0800

sddm (0.12.0-5) unstable; urgency=medium

  * Team upload.

  [ Maximiliano Curia ]
  * Delete the sddm.log file on purge. (Closes: #793679)
  * The themes shipped with sddm need the latest version, using breaks
    instead of depends to avoid circular deps. (Closes: #800462) Thanks
    to Max Görner

  [ Matthias Klumpp ]
  * Fix deadlock in sddm.service when waiting for Plymouth to quit

  [ Scott Kitterman ]
  * Add debian/patches/CVE-2015-0856.patch to fix potential issue if an SDDM
    theme crashes while running the KDE debug handler (Closes: #803338)

 -- Scott Kitterman <scott@kitterman.com>  Thu, 29 Oct 2015 00:01:45 -0400

sddm (0.12.0-4) unstable; urgency=medium

  * Fix indep build. (Closes: #799142) Thanks to Boris Pek

 -- Maximiliano Curia <maxy@debian.org>  Wed, 16 Sep 2015 15:06:00 +0200

sddm (0.12.0-3) unstable; urgency=medium

  * Update service file, run after plymouth-quit-wait.
  * Re add patch: 04_set_default_path.diff

 -- Maximiliano Curia <maxy@debian.org>  Mon, 14 Sep 2015 21:22:30 +0200

sddm (0.12.0-2) unstable; urgency=medium

  * Team upload
  * Ensure SDDM waits for Plymouth and getty to quit before starting
    (Closes: #793637)
  * Drop some unnecessary patches
  * Suggest libpam-kwallet5 instead of pam-kwallet5

 -- Matthias Klumpp <mak@debian.org>  Sat, 12 Sep 2015 16:32:50 +0200

sddm (0.12.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release: 0.12.0
  * Drop patches which are applied upstream
  * Refresh and reorganize remaining patches
  * debian/rules: Compile with DBUS_CONFIG_FILENAME set to non-conflicting name
  * Ensure Xsession script is marked as executable
  * Don't fail when purging sddm

 -- Matthias Klumpp <mak@debian.org>  Sat, 05 Sep 2015 22:02:54 +0200

sddm (0.11.0-4) unstable; urgency=medium

  [ Scott Kitterman ]
  * Team upload.
  * Add Provides: x-display-manager for sddm (Closes: 795006)

  [ Maximiliano Curia ]
  * Add the Xsession script. (Closes: #794419)
  * New patch: default_path

 -- Maximiliano Curia <maxy@debian.org>  Thu, 03 Sep 2015 17:23:08 +0200

sddm (0.11.0-3) unstable; urgency=medium

  * Transition to libsystemd-dev. (Closes: #792400) Thanks to Michael
    Biebl
  * New patch: libsystemd.diff
  * Fix systemctl path. (Closes: #792401) Thanks to Michael Biebl
  * New patch: sddm_systemctl.diff
  * Update debian/po files. (Closes: #792085) Thanks to Christian
    Perrier

 -- Maximiliano Curia <maxy@debian.org>  Sat, 18 Jul 2015 21:34:44 +0200

sddm (0.11.0-2) unstable; urgency=medium

  [ Maximiliano Curia ]
  * Re-enable patches kubuntu_use_breeze.diff, kubuntu_minimum_vt.diff,
    upstream_add-graphical.target.diff.
  * Re-enable libpam-gnome-keyring.

  [ Pino Toscano ]
  * Make sddm build on non-Linux architectures:
    - limit the libsystemd-login-dev build dependency as linux-any
    - properly use DEB_HOST_ARCH_OS for detecting the current target OS
    - explicitly disable systemd and journald on non-Linux archs
    - disable installation of the upstream lib/systemd/system/sddm.service
      (installed only with systemd support enabled), as there is a local
      debian/sddm.service which will be used anyway instead

 -- Maximiliano Curia <maxy@debian.org>  Thu, 09 Jul 2015 15:20:08 +0200

sddm (0.11.0-1) experimental; urgency=medium

  [ Michał Zając ]
  * Initial release (LP: #1157742)

  [ Maximiliano Curia ]
  * New upstream release (0.10.0).
  * New upstream release (0.11.0).
  * Update copyright information.

 -- Maximiliano Curia <maxy@debian.org>  Fri, 27 Mar 2015 21:27:38 +0100

sddm (0.11.0-0ubuntu12) xenial; urgency=high

  * Replace libsystemd-login-dev with libsystemd-dev.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 04 Jan 2016 14:25:10 +0000

sddm (0.11.0-0ubuntu11) wily; urgency=medium

  * Fix postrm to remove what was if'd for as to avoid failure.
  * Add pam_kwallet5 to the pam profile rules. It is the same version as


=== debian/control ===
--- 
+++ 
@@ -2,17 +2,19 @@
 Section: kde
 Priority: optional
 Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
-Uploaders: Michał Zając <quintasan@kubuntu.org>
+Uploaders: Michał Zając <quintasan@kubuntu.org>,
+           Maximiliano Curia <maxy@debian.org>
 Build-Depends: cmake (>= 2.8.8),
                debhelper (>= 9),
+               python-docutils,
                dh-systemd [linux-any],
                libpam0g-dev,
-               libsystemd-login-dev,
+               libsystemd-dev [linux-any],
                libupower-glib-dev,
                libxcb-xkb-dev,
                libxcb1-dev,
                pkg-config,
-               qtbase5-dev,
+               qtbase5-dev (>= 5.4),
                qtdeclarative5-dev,
                qttools5-dev,
                qttools5-dev-tools,
@@ -29,6 +31,9 @@
          sddm-theme-breeze | sddm-theme,
          ${misc:Depends},
          ${shlibs:Depends}
+Recommends: libpam-systemd
+Suggests: libpam-kwallet5
+Provides: x-display-manager
 Description: modern display manager for X11
  SDDM is a modern display manager for X11 aiming to be fast, simple
  and beautiful. It uses modern technologies like QtQuick to create
@@ -37,6 +42,7 @@
 Package: sddm-theme-maui
 Architecture: all
 Depends: ${misc:Depends}
+Breaks: sddm (<< ${source:Version})
 Recommends: sddm
 Provides: sddm-theme
 Description: 'Maui' theme for SDDM X11 display manager
@@ -45,6 +51,7 @@
 Package: sddm-theme-circles
 Architecture: all
 Depends: ${misc:Depends}
+Breaks: sddm (<< ${source:Version})
 Recommends: sddm
 Provides: sddm-theme
 Description: 'Circles' theme for SDDM X11 display manager
@@ -55,19 +62,23 @@
 Depends: ${misc:Depends}
 Recommends: sddm
 Provides: sddm-theme
+Breaks: sddm (<< ${source:Version})
 Description: 'Elarun' Theme for SDDM X11 display manager
  Elarun theme for SDDM
 
 Package: sddm-theme-maldives
 Architecture: all
 Depends: ${misc:Depends}
+Breaks: sddm (<< ${source:Version})
 Recommends: sddm
 Provides: sddm-theme
 Description: 'Maldives' theme for SDDM X11 display manager
  Maldives theme for SDDM
 
 Package: sddm-dbg
-Depends: sddm (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: sddm (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Architecture: any
 Section: debug
 Priority: extra

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

SDDM_CMAKE_ARGS = -DCMAKE_INSTALL_LIBEXECDIR=/usr/lib/${DEB_HOST_MULTIARCH}/sddm \
	    -DSESSION_COMMAND="/etc/sddm/Xsession" \
	    -DBUILD_MAN_PAGES=ON \
	    -DDBUS_CONFIG_FILENAME="sddm_org.freedesktop.DisplayManager.conf"

ifeq ($(DEB_HOST_ARCH_OS),linux)
  WITH_SYSTEMD := --with systemd
else
  SDDM_CMAKE_ARGS += -DNO_SYSTEMD=ON -DENABLE_JOURNALD=OFF
endif

%:
	dh $@ ${WITH_SYSTEMD} --parallel

override_dh_strip:
	dh_strip --dbg-package=sddm-dbg

override_dh_auto_configure:
	dh_auto_configure -- ${SDDM_CMAKE_ARGS}

override_dh_systemd_start:
	dh_systemd_start -psddm --no-start -r sddm.service

override_dh_installinit:
	dh_installinit --noscripts

override_dh_install:
	# not installed, as the Debian version is used instead
	rm -f $(CURDIR)/debian/tmp/lib/systemd/system/sddm.service
	dh_install --list-missing

override_dh_fixperms-arch:
	# ensure script is marked as executable
	chmod +x $(CURDIR)/debian/sddm/etc/sddm/Xsession
	dh_fixperms

override_dh_installpam:
	dh_installpam
	dh_installpam --name=sddm-autologin
	dh_installpam --name=sddm-greeter

## sddm 0.14.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,6 @@
 
 project(SDDM)
 
-set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}")
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(CMAKE_AUTOMOC ON)
 SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
@@ -14,7 +13,7 @@
 
 # Set version
 set(SDDM_VERSION_MAJOR 0)
-set(SDDM_VERSION_MINOR 13)
+set(SDDM_VERSION_MINOR 14)
 set(SDDM_VERSION_PATCH 0)
 set(SDDM_VERSION_STRING "${SDDM_VERSION_MAJOR}.${SDDM_VERSION_MINOR}.${SDDM_VERSION_PATCH}")
 
@@ -33,6 +32,10 @@
 option(ENABLE_JOURNALD "Enable logging to journald" ON)
 option(ENABLE_PAM "Enable PAM support" ON)
 
+# ECM
+find_package(ECM 1.4.0 REQUIRED NO_MODULE)
+set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH};${ECM_MODULE_PATH}")
+
 # Definitions
 add_definitions(-Wall -std=c++11 -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_FROM_BYTEARRAY)
 
@@ -86,9 +89,7 @@
 find_package(XKB REQUIRED)
 
 # Qt 5
-find_package(Qt5Core REQUIRED)
-find_package(Qt5DBus REQUIRED)
-find_package(Qt5LinguistTools REQUIRED)
+find_package(Qt5 5.6.0 CONFIG REQUIRED Core DBus Gui Qml Quick LinguistTools)
 
 # find qt5 imports dir
 get_target_property(QMAKE_EXECUTABLE Qt5::qmake LOCATION)
@@ -100,11 +101,12 @@
 set(COMPONENTS_VERSION 2.0)
 
 # Uninstall target
-configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
-               "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
-               IMMEDIATE @ONLY)
-
-add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
+if ("${ECM_VERSION}" VERSION_LESS "1.7.0")
+    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
+                   "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
+                   IMMEDIATE @ONLY)
+    add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
+endif()
 
 # systemd
 if(NOT NO_SYSTEMD)
@@ -145,6 +147,8 @@
     set(HALT_COMMAND "/sbin/shutdown -h -P now")
     set(REBOOT_COMMAND "/sbin/shutdown -r now")
 endif()
+add_feature_info("systemd" SYSTEMD_FOUND "systemd support")
+add_feature_info("journald" JOURNALD_FOUND "journald support")
 
 # Set constants
 set(DATA_INSTALL_DIR            "${CMAKE_INSTALL_FULL_DATADIR}/sddm"                CACHE PATH      "System application data install directory")

=== data/themes/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-set(THEMES circles elarun maldives maui)
+set(THEMES elarun maldives)
 
 foreach(THEME ${THEMES})
     # We assume that theme-specific translations are stored

=== data/translations/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,6 @@
 set(TRANSLATION_FILES
     ar.ts
+    ca.ts
     cs.ts
     de.ts
     es.ts
@@ -12,6 +13,8 @@
     ko.ts
     lt.ts
     lv.ts
+    nb.ts
+    nn.ts
     pl.ts
     pt_BR.ts
     pt_PT.ts
@@ -20,6 +23,7 @@
     sr@ijekavian.ts
     sr@ijekavianlatin.ts
     sr@latin.ts
+    sv.ts
     ru.ts
     tr.ts
     zh_CN.ts

=== src/daemon/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,8 @@
     ${CMAKE_SOURCE_DIR}/src/common/Configuration.cpp
     ${CMAKE_SOURCE_DIR}/src/common/SafeDataStream.cpp
     ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.cpp
+    ${CMAKE_SOURCE_DIR}/src/common/ThemeConfig.cpp
+    ${CMAKE_SOURCE_DIR}/src/common/ThemeMetadata.cpp
     ${CMAKE_SOURCE_DIR}/src/common/Session.cpp
     ${CMAKE_SOURCE_DIR}/src/common/SocketWriter.cpp
     ${CMAKE_SOURCE_DIR}/src/auth/Auth.cpp
@@ -32,16 +34,28 @@
 qt5_add_dbus_adaptor(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.DisplayManager.Session.xml"  "DisplayManager.h" SDDM::DisplayManagerSession)
 
 add_executable(sddm ${DAEMON_SOURCES})
-target_link_libraries(sddm ${LIBXCB_LIBRARIES})
+target_link_libraries(sddm
+                      Qt5::DBus
+                      Qt5::Network
+                      Qt5::Qml
+                      ${LIBXCB_LIBRARIES})
 if(PAM_FOUND)
     target_link_libraries(sddm ${PAM_LIBRARIES})
 else()
     target_link_libraries(sddm crypt)
 endif()
-qt5_use_modules(sddm DBus Network Qml)
 
 if(JOURNALD_FOUND)
     target_link_libraries(sddm ${JOURNALD_LIBRARIES})
 endif()
 
 install(TARGETS sddm DESTINATION "${CMAKE_INSTALL_BINDIR}")
+
+# Generate and install the default config file
+add_custom_command(COMMAND sddm --example-config > "${CMAKE_BINARY_DIR}/sddm.conf"
+    OUTPUT "${CMAKE_BINARY_DIR}/sddm.conf"
+    COMMENT "Generate default sddm.conf file"
+    DEPENDS sddm
+)
+add_custom_target(generate_config_file ALL DEPENDS "${CMAKE_BINARY_DIR}/sddm.conf")
+install(FILES "${CMAKE_BINARY_DIR}/sddm.conf" DESTINATION "${CMAKE_INSTALL_FULL_SYSCONFDIR}")

=== src/greeter/CMakeLists.txt ===
--- 
+++ 
@@ -6,21 +6,28 @@
     ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.cpp
     ${CMAKE_SOURCE_DIR}/src/common/Session.cpp
     ${CMAKE_SOURCE_DIR}/src/common/SocketWriter.cpp
+    ${CMAKE_SOURCE_DIR}/src/common/ThemeConfig.cpp
+    ${CMAKE_SOURCE_DIR}/src/common/ThemeMetadata.cpp
     GreeterApp.cpp
     GreeterProxy.cpp
     KeyboardLayout.cpp
     KeyboardModel.cpp
     ScreenModel.cpp
     SessionModel.cpp
-    ThemeConfig.cpp
-    ThemeMetadata.cpp
     UserModel.cpp
     XcbKeyboardBackend.cpp
 )
 
-add_executable(sddm-greeter ${GREETER_SOURCES})
-target_link_libraries(sddm-greeter ${LIBXCB_LIBRARIES} ${LIBXKB_LIBRARIES})
-qt5_use_modules(sddm-greeter Quick)
+configure_file("theme/Main.qml"                  "theme/Main.qml")
+configure_file("theme.qrc"                       "theme.qrc")
+
+qt5_add_resources(RESOURCES ${CMAKE_CURRENT_BINARY_DIR}/theme.qrc)
+
+add_executable(sddm-greeter ${GREETER_SOURCES} ${RESOURCES})
+target_link_libraries(sddm-greeter
+                      Qt5::Quick
+                      ${LIBXCB_LIBRARIES}
+                      ${LIBXKB_LIBRARIES})
 
 if(JOURNALD_FOUND)
     target_link_libraries(sddm-greeter ${JOURNALD_LIBRARIES})

=== src/helper/CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,7 @@
 endif()
 
 add_executable(sddm-helper ${HELPER_SOURCES})
-qt5_use_modules(sddm-helper Network)
+target_link_libraries(sddm-helper Qt5::Network)
 if(PAM_FOUND)
     target_link_libraries(sddm-helper ${PAM_LIBRARIES})
 else()

=== debian/changelog ===
sddm (0.14.0-4ubuntu1) artful; urgency=medium

  [ Simon Quigley ]
  * New upstream release (LP: #1627340).
  * Merge from Debian. Remaining changes:
    - Keep the default-display-manager file logic in sddm.postinst.
    - Keep kubuntu-specific patches:
      + kubuntu_nvidia-prime.diff
      + kubuntu_minimum_vt.diff instead of 03_vt7-minimum-vt.diff
  * Dropped changes:
    - Remove debian/patches/upstream_autologin_fallback.diff as it's
      reverse-applicable.
  * Refresh patches.

  [ Clive Johnston ]
  * Re-apply 02_kubuntu_use_breeze.diff
  * Update VCS to LP and replace maui theme for breeze in recommends.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Tue, 02 May 2017 18:55:40 +0100

sddm (0.14.0-4) unstable; urgency=medium

  * Update documentation, add information about HiDPI

 -- Maximiliano Curia <maxy@debian.org>  Tue, 14 Mar 2017 09:50:33 +0100

sddm (0.14.0-3) unstable; urgency=medium

  * Drop pam_systemd.so from our pam rules.
    Thanks to Russell Coker for reporting (Closes: 850006)
  * Add new upstream patch: Fix-display-of-user-avatars.-684.patch.
    Thanks to Salvo Tomaselli for reporting (Closes: 856195)
  * Create sddm's home dir if not present
  * Add HiDPI patches:
    Add-a-config-option-to-enable-high-DPI-scaling-701.patch (upstream) and
    Regression-fix-disable-HiDPI-by-default.patch.
    Thanks to Laurent Bonnaud for reporting and testing (Closes: 853843)

 -- Maximiliano Curia <maxy@debian.org>  Sun, 12 Mar 2017 17:33:04 +0100

sddm (0.14.0-2) unstable; urgency=medium

  * Avoid killing plymouth from the sddm system unit (Closes: 854260)
  * Purge dangling symlink.
    Thanks to Andreas Beckmann for following this issue (Closes: 848936)
  * Install the generated configuration file as an example
  * Workaround debconf's db_purge stdout parsing (#855912)
    Thanks to Laurent Bonnaud for reporting (Closes: 853844)

 -- Maximiliano Curia <maxy@debian.org>  Mon, 20 Feb 2017 19:09:24 +0100

sddm (0.14.0-1) experimental; urgency=medium

  [ Maximiliano Curia ]
  * New upstream release (0.14.0).
  * Add missing xserver dependencies. (Closes: 833080)
  * Refresh patches
  * Update build-deps and deps with the info from cmake
  * Drop maui and circles themes
  * Bump Standards-Version to 3.9.8
  * Add a .gitattributes file to use dpkg-mergechangelogs
  * Migrate dbg package to automatic dbgsym
  * debian/control: Update Vcs-Browser and Vcs-Git fields
  * Demote the breeze theme to a recommends
  * Add a basic README.Debian for the sddm configuration and themes
  * Add new patch: handle-reading-from-a-closed-file-handle.patch

  [ Aurélien COUDERC ]
  * Add SDDM themes based on Debian arwork, make default theme configurable with alternatives

 -- Maximiliano Curia <maxy@debian.org>  Fri, 30 Dec 2016 20:41:13 +0100

=== debian/control ===
Source: sddm
Section: kde
Priority: optional
Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Michał Zając <quintasan@kubuntu.org>,
           Maximiliano Curia <maxy@debian.org>
Build-Depends: cmake (>= 2.8.8),
               debhelper (>= 9),
               dh-systemd [linux-any],
               extra-cmake-modules (>= 1.4.0~),
               libpam0g-dev,
               libsystemd-dev [linux-any],
               libupower-glib-dev,
               libxcb-xkb-dev,
               libxcb1-dev,
               libxkbcommon-dev,
               pkg-config,
               python-docutils,
               qtbase5-dev (>= 5.6.0~),
               qtdeclarative5-dev (>= 5.6.0~),
               qttools5-dev,
               qttools5-dev-tools (>= 5.6.0~),
               systemd [linux-any]
Standards-Version: 3.9.8
Homepage: https://github.com/sddm/sddm
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/sddm
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/sddm

Package: sddm
Architecture: any
Depends: adduser,
         qml-module-qtquick2,
         x11-common,
         xserver-xorg | xserver,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: libpam-systemd, sddm-theme-breeze | sddm-theme
Suggests: libpam-kwallet5
Provides: x-display-manager
Description: modern display manager for X11
 SDDM is a modern display manager for X11 aiming to be fast, simple
 and beautiful. It uses modern technologies like QtQuick to create
 smooth, animated user interfaces.

Package: sddm-theme-maui
Architecture: all
Depends: ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Maui' theme for SDDM X11 display manager
 Maui theme for SDDM

Package: sddm-theme-debian-maui
Architecture: all
Depends: desktop-base, ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Debian Maui' theme for SDDM X11 display manager
 Maui theme for SDDM, using the active desktop-base theme for the
 background

Package: sddm-theme-elarun
Architecture: all
Depends: ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Elarun' Theme for SDDM X11 display manager
 Elarun theme for SDDM

Package: sddm-theme-debian-elarun
Architecture: all
Depends: desktop-base, ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Debian Elarun' Theme for SDDM X11 display manager
 Elarun theme for SDDM, using the active desktop-base theme for the
 background.

Package: sddm-theme-maldives
Architecture: all
Depends: ${misc:Depends}
Breaks: sddm (<< ${source:Version})
Recommends: sddm
Provides: sddm-theme
Description: 'Maldives' theme for SDDM X11 display manager
 Maldives theme for SDDM
